-- name: Wallkick Anywhere v3
-- description: Wallkick out of any bonk action.\nCreated by Sunk

local can_wallkick = false
---@param m MarioState
function on_set_mario_action(m)
    if m.playerIndex ~= 0 then return end

    can_wallkick = false
    if m.action == ACT_BACKWARD_AIR_KB or m.action == ACT_SOFT_BONK then
        can_wallkick = true
    end
end

local wallkick_timer = 5
---@param m MarioState
function mario_update(m)
    if m.playerIndex ~= 0 then return end

    if can_wallkick then
        if m.controller.buttonPressed & A_BUTTON ~= 0 and wallkick_timer > 0 then
            wallkick_timer = 5
            mario_bonk_reflection(m, 0)
            set_mario_action(m, ACT_WALL_KICK_AIR, 0)
        end
        wallkick_timer = wallkick_timer - 1
    else
        wallkick_timer = 5
    end
end

hook_event(HOOK_ON_SET_MARIO_ACTION, on_set_mario_action)
hook_event(HOOK_MARIO_UPDATE, mario_update)